#ifndef PSYCO_H
#define PSYCO_H
//#include <iostream>


class Psyco
{
public:
    //Psyco();
    Psyco(const int patch_dim, const float * bases);
    ~Psyco();

    void obtainTransfElement (bool * transf_element, const float * patch);
    void applyTransfElement (float * transf_patch, const bool * transf_element, const float * patch);
    void revertTransfElement (float * recovered_patch, const bool * transf_element, const float * transf_patch);
    void applyTransfPar (float * transf_patches, bool * transf_elements, const float * patches, const int n_patches); // Parallel method
    void revertTransfPar (float * reverted_patches, const bool * transf_elements, const float * transf_patches, const int n_patches); // Parallel method


    int getDim () {return(this->patch_dim);};
    int getSide () {return(this->patch_side);};


protected:
    int patch_side;
    int patch_dim;
    float * t_bases;

    void static matVecMultiplication (const float *matrix, const float *vector, float *x, const int matrix_rows, const int vector_dim);



};

#endif // PSYCO_H
