#include "Psyco.h"
#ifndef PSYCOSUPERRES_H
#define PSYCOSUPERRES_H


class PsycoSuperRes : private Psyco
{
public:
    PsycoSuperRes(const float * anch_features, const float * regressors, const int n_regressors, const float * global_regressor, const int step, const int border,
                  const int upscaling_factor, const float * pivots, const int n_spheres, const float * thresholds, const int * bucket_sizes, const int * acum_sizes,
                  const int n_side, const float * bases);
    ~PsycoSuperRes();

    void upscaleImagePar(float * upscaled_im, const float * image, const int n_rows, const int n_cols);

private:
    int upscaling_factor;

    // Regression variables
    float * anchored_features;
    float * regressors;
    float * global_regressor;
    int n_regressors;

    // Sliding window variables
    int step;
    int border;

    // Spherical Hashing variables
    float * pivots;
    float * thresholds;
    int * bucket_sizes;
    int * acum_sizes;
    int n_spheres;

    void noMeanNormalizePatch (float * output_patch, float * patch);
    float static dotProduct(const float * patch1, const float  * patch2, const int dim);
    //void static sumPatch (float * output_patch, const float * patch1, const float * patch2, const int n_dims);
    int getHash(float * patch);

};

#endif // UPSCALER_H
