%CLASS_INTERFACE Example MATLAB class wrapper to an underlying C++ class
classdef Psyco < handle
    properties (SetAccess = private, Hidden = true)
        objectHandle; % Handle to the underlying C++ class instance
    end
    methods
        %% Constructor - Create a new C++ class instance 
        function this = Psyco(varargin)
            this.objectHandle = Psyco_interface_mex('new', varargin{:});
        end
        
        %% Destructor - Destroy the C++ class instance
        function delete(this)
            Psyco_interface_mex('delete', this.objectHandle);
        end

        %% Train - an example class method call
        function varargout = getDim(this, varargin)
            [varargout{1:nargout}] = Psyco_interface_mex('getDim', this.objectHandle, varargin{:});
        end

        %% Test - another example class method call
        function varargout = getSide(this, varargin)
            [varargout{1:nargout}] = Psyco_interface_mex('getSide', this.objectHandle, varargin{:});
        end
        
         %% obtainTransfElement - another example class method call
        function varargout = obtainTransfElement(this, varargin)
            [varargout{1:nargout}] = Psyco_interface_mex('obtainTransfElement', this.objectHandle, varargin{:});
        end
        
        %% applyTransfElement - another example class method call
        function varargout = applyTransfElement(this, varargin)
            [varargout{1:nargout}] = Psyco_interface_mex('applyTransfElement', this.objectHandle, varargin{:});
        end
        
        %% revertTransfElement - another example class method call
        function varargout = revertTransfElement(this, varargin)
            [varargout{1:nargout}] = Psyco_interface_mex('revertTransfElement', this.objectHandle, varargin{:});
        end
        
        
        %% applyTransfPar - another example class method call
        function varargout = applyTransfPar(this, varargin)
            [varargout{1:nargout}] = Psyco_interface_mex('applyTransfPar', this.objectHandle, varargin{:});
        end
        
    end
end