%CLASS_INTERFACE Example MATLAB class wrapper to an underlying C++ class
classdef PsycoSuperRes < handle
    properties (SetAccess = private, Hidden = true)
        objectHandle; % Handle to the underlying C++ class instance
    end
    methods
        %% Constructor - Create a new C++ class instance 
        function this = PsycoSuperRes(varargin)
            this.objectHandle = PsycoSuperRes_interface_mex('new', varargin{:});
        end
        
        %% Destructor - Destroy the C++ class instance
        function delete(this)
            PsycoSuperRes_interface_mex('delete', this.objectHandle);
        end

                
        %% applyTransfPar - another example class method call
        function varargout = upscaleImagePar(this, varargin)
            [varargout{1:nargout}] = PsycoSuperRes_interface_mex('upscaleImagePar', this.objectHandle, varargin{:});
        end
        
    end
end